--- /dev/null	Mon Nov 18 13:20:18 2019
+++ new/usr/src/tools/smatch/src/validation/linear/logical.c	Mon Nov 18 13:20:18 2019
@@ -0,0 +1,260 @@
+struct S {
+	         int  :1;
+	  signed int s:2;
+	unsigned int u:3;
+	        long l;
+	      double d;
+};
+
+int os(int i, struct S *b) { return i || b->s; }
+int ou(int i, struct S *b) { return i || b->u; }
+int ol(int i, struct S *b) { return i || b->l; }
+int od(int i, struct S *b) { return i || b->d; }
+
+int as(int i, struct S *b) { return i && b->s; }
+int au(int i, struct S *b) { return i && b->u; }
+int al(int i, struct S *b) { return i && b->l; }
+int ad(int i, struct S *b) { return i && b->d; }
+
+/*
+ * check-name: logical
+ * check-command: test-linearize -m64 -fdump-ir -Wno-decl $file
+ * check-assert: sizeof(void *) == 8 && sizeof(long) == 8 && sizeof(double) == 8
+ *
+ * check-output-start
+os:
+.L0:
+	<entry-point>
+	store.32    %arg1 -> 0[i]
+	store.64    %arg2 -> 0[b]
+	load.32     %r2 <- 0[i]
+	setne.1     %r3 <- %r2, $0
+	phisrc.32   %phi1 <- $1
+	cbr         %r3, .L3, .L2
+
+.L2:
+	load.64     %r4 <- 0[b]
+	load.32     %r5 <- 0[%r4]
+	lsr.32      %r6 <- %r5, $1
+	trunc.2     %r7 <- (32) %r6
+	setne.1     %r8 <- %r7, $0
+	zext.32     %r9 <- (1) %r8
+	phisrc.32   %phi2 <- %r9
+	br          .L3
+
+.L3:
+	phi.32      %r1 <- %phi1, %phi2
+	phisrc.32   %phi3(return) <- %r1
+	br          .L1
+
+.L1:
+	phi.32      %r10 <- %phi3(return)
+	ret.32      %r10
+
+
+ou:
+.L4:
+	<entry-point>
+	store.32    %arg1 -> 0[i]
+	store.64    %arg2 -> 0[b]
+	load.32     %r12 <- 0[i]
+	setne.1     %r13 <- %r12, $0
+	phisrc.32   %phi4 <- $1
+	cbr         %r13, .L7, .L6
+
+.L6:
+	load.64     %r14 <- 0[b]
+	load.32     %r15 <- 0[%r14]
+	lsr.32      %r16 <- %r15, $3
+	trunc.3     %r17 <- (32) %r16
+	setne.1     %r18 <- %r17, $0
+	zext.32     %r19 <- (1) %r18
+	phisrc.32   %phi5 <- %r19
+	br          .L7
+
+.L7:
+	phi.32      %r11 <- %phi4, %phi5
+	phisrc.32   %phi6(return) <- %r11
+	br          .L5
+
+.L5:
+	phi.32      %r20 <- %phi6(return)
+	ret.32      %r20
+
+
+ol:
+.L8:
+	<entry-point>
+	store.32    %arg1 -> 0[i]
+	store.64    %arg2 -> 0[b]
+	load.32     %r22 <- 0[i]
+	setne.1     %r23 <- %r22, $0
+	phisrc.32   %phi7 <- $1
+	cbr         %r23, .L11, .L10
+
+.L10:
+	load.64     %r24 <- 0[b]
+	load.64     %r25 <- 8[%r24]
+	setne.1     %r26 <- %r25, $0
+	zext.32     %r27 <- (1) %r26
+	phisrc.32   %phi8 <- %r27
+	br          .L11
+
+.L11:
+	phi.32      %r21 <- %phi7, %phi8
+	phisrc.32   %phi9(return) <- %r21
+	br          .L9
+
+.L9:
+	phi.32      %r28 <- %phi9(return)
+	ret.32      %r28
+
+
+od:
+.L12:
+	<entry-point>
+	store.32    %arg1 -> 0[i]
+	store.64    %arg2 -> 0[b]
+	load.32     %r30 <- 0[i]
+	setne.1     %r31 <- %r30, $0
+	phisrc.32   %phi10 <- $1
+	cbr         %r31, .L15, .L14
+
+.L14:
+	load.64     %r32 <- 0[b]
+	load.64     %r33 <- 16[%r32]
+	setfval.64  %r34 <- 0.000000e+00
+	fcmpune.1   %r35 <- %r33, %r34
+	zext.32     %r36 <- (1) %r35
+	phisrc.32   %phi11 <- %r36
+	br          .L15
+
+.L15:
+	phi.32      %r29 <- %phi10, %phi11
+	phisrc.32   %phi12(return) <- %r29
+	br          .L13
+
+.L13:
+	phi.32      %r37 <- %phi12(return)
+	ret.32      %r37
+
+
+as:
+.L16:
+	<entry-point>
+	store.32    %arg1 -> 0[i]
+	store.64    %arg2 -> 0[b]
+	load.32     %r39 <- 0[i]
+	setne.1     %r40 <- %r39, $0
+	phisrc.32   %phi13 <- $0
+	cbr         %r40, .L18, .L19
+
+.L18:
+	load.64     %r41 <- 0[b]
+	load.32     %r42 <- 0[%r41]
+	lsr.32      %r43 <- %r42, $1
+	trunc.2     %r44 <- (32) %r43
+	setne.1     %r45 <- %r44, $0
+	zext.32     %r46 <- (1) %r45
+	phisrc.32   %phi14 <- %r46
+	br          .L19
+
+.L19:
+	phi.32      %r38 <- %phi13, %phi14
+	phisrc.32   %phi15(return) <- %r38
+	br          .L17
+
+.L17:
+	phi.32      %r47 <- %phi15(return)
+	ret.32      %r47
+
+
+au:
+.L20:
+	<entry-point>
+	store.32    %arg1 -> 0[i]
+	store.64    %arg2 -> 0[b]
+	load.32     %r49 <- 0[i]
+	setne.1     %r50 <- %r49, $0
+	phisrc.32   %phi16 <- $0
+	cbr         %r50, .L22, .L23
+
+.L22:
+	load.64     %r51 <- 0[b]
+	load.32     %r52 <- 0[%r51]
+	lsr.32      %r53 <- %r52, $3
+	trunc.3     %r54 <- (32) %r53
+	setne.1     %r55 <- %r54, $0
+	zext.32     %r56 <- (1) %r55
+	phisrc.32   %phi17 <- %r56
+	br          .L23
+
+.L23:
+	phi.32      %r48 <- %phi16, %phi17
+	phisrc.32   %phi18(return) <- %r48
+	br          .L21
+
+.L21:
+	phi.32      %r57 <- %phi18(return)
+	ret.32      %r57
+
+
+al:
+.L24:
+	<entry-point>
+	store.32    %arg1 -> 0[i]
+	store.64    %arg2 -> 0[b]
+	load.32     %r59 <- 0[i]
+	setne.1     %r60 <- %r59, $0
+	phisrc.32   %phi19 <- $0
+	cbr         %r60, .L26, .L27
+
+.L26:
+	load.64     %r61 <- 0[b]
+	load.64     %r62 <- 8[%r61]
+	setne.1     %r63 <- %r62, $0
+	zext.32     %r64 <- (1) %r63
+	phisrc.32   %phi20 <- %r64
+	br          .L27
+
+.L27:
+	phi.32      %r58 <- %phi19, %phi20
+	phisrc.32   %phi21(return) <- %r58
+	br          .L25
+
+.L25:
+	phi.32      %r65 <- %phi21(return)
+	ret.32      %r65
+
+
+ad:
+.L28:
+	<entry-point>
+	store.32    %arg1 -> 0[i]
+	store.64    %arg2 -> 0[b]
+	load.32     %r67 <- 0[i]
+	setne.1     %r68 <- %r67, $0
+	phisrc.32   %phi22 <- $0
+	cbr         %r68, .L30, .L31
+
+.L30:
+	load.64     %r69 <- 0[b]
+	load.64     %r70 <- 16[%r69]
+	setfval.64  %r71 <- 0.000000e+00
+	fcmpune.1   %r72 <- %r70, %r71
+	zext.32     %r73 <- (1) %r72
+	phisrc.32   %phi23 <- %r73
+	br          .L31
+
+.L31:
+	phi.32      %r66 <- %phi22, %phi23
+	phisrc.32   %phi24(return) <- %r66
+	br          .L29
+
+.L29:
+	phi.32      %r74 <- %phi24(return)
+	ret.32      %r74
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:18 2019
+++ new/usr/src/tools/smatch/src/validation/linear/missing-return0.c	Mon Nov 18 13:20:18 2019
@@ -0,0 +1,10 @@
+static int foo(int a)
+{
+	if (a)
+		return 1;
+}
+
+/*
+ * check-name: missing-return0
+ * check-command: sparse -vir -flinearize=last $file
+ */
--- /dev/null	Mon Nov 18 13:20:18 2019
+++ new/usr/src/tools/smatch/src/validation/linear/missing-return1.c	Mon Nov 18 13:20:18 2019
@@ -0,0 +1,15 @@
+static inline int fun(int a)
+{
+	if (a)
+		return 1;
+}
+
+static int foo(int a)
+{
+	return fun(a);
+}
+
+/*
+ * check-name: missing-return1
+ * check-command: sparse -vir -flinearize=last $file
+ */
--- /dev/null	Mon Nov 18 13:20:19 2019
+++ new/usr/src/tools/smatch/src/validation/linear/missing-return2.c	Mon Nov 18 13:20:19 2019
@@ -0,0 +1,11 @@
+static int foo(int a)
+{
+	switch (a)
+	case 3:
+		return 4;
+}
+
+/*
+ * check-name: missing-return2
+ * check-command: sparse -vir -flinearize=last $file
+ */
--- /dev/null	Mon Nov 18 13:20:19 2019
+++ new/usr/src/tools/smatch/src/validation/linear/missing-return3.c	Mon Nov 18 13:20:19 2019
@@ -0,0 +1,18 @@
+static int foo(int a)
+{
+	if (a)
+		return;
+}
+
+static void ref(void)
+{
+}
+
+/*
+ * check-name: missing-return3
+ * check-command: sparse -vir -flinearize=last $file
+ *
+ * check-error-start
+linear/missing-return3.c:4:17: error: return with no return value
+ * check-error-end
+ */
--- /dev/null	Mon Nov 18 13:20:19 2019
+++ new/usr/src/tools/smatch/src/validation/linear/missing-return4.c	Mon Nov 18 13:20:19 2019
@@ -0,0 +1,14 @@
+static int foo(int a)
+{
+	int r = a;
+	r;
+}
+
+/*
+ * check-name: missing-return4
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-error-ignore
+ * check-output-ignore
+ * check-output-contains: ret\\..*UNDEF
+ */
--- /dev/null	Mon Nov 18 13:20:19 2019
+++ new/usr/src/tools/smatch/src/validation/linear/missing-return5.c	Mon Nov 18 13:20:19 2019
@@ -0,0 +1,23 @@
+int foo(int p)
+{
+	if (p)
+		return 0;
+}
+
+int bar(int p)
+{
+	if (p)
+		return 0;
+	p++;
+}
+
+/*
+ * check-name: missing/undef return
+ * check-command: test-linearize -Wno-decl -fdump-ir=linearize $file
+ *
+ * check-output-ignore
+ * check-output-pattern(2): phi\\..*,.*
+ * check-output-pattern(2): phisrc\\..*\\$0
+ * check-output-pattern(2): phisrc\\..*UNDEF
+ * check-output-excludes: ret\\..*\\$0
+ */
--- /dev/null	Mon Nov 18 13:20:19 2019
+++ new/usr/src/tools/smatch/src/validation/linear/non-const-case.c	Mon Nov 18 13:20:19 2019
@@ -0,0 +1,37 @@
+static int foo(int a)
+{
+	switch (a) {
+	case 0:
+		return a;
+	case a:
+		return 0;
+	case (a - a):
+		return 1;
+	default:
+		return a;
+	}
+}
+
+static int bar(int a)
+{
+	switch (a) {
+	case 0:
+		break;
+	case a:
+		a++;
+label:
+		return a;
+	}
+
+	goto label;
+}
+
+
+/*
+ * check-name: non-const-case
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-error-ignore
+ * check-output-ignore
+ * check-output-excludes:switch \\.
+ */
--- /dev/null	Mon Nov 18 13:20:19 2019
+++ new/usr/src/tools/smatch/src/validation/linear/phi-order01.c	Mon Nov 18 13:20:19 2019
@@ -0,0 +1,16 @@
+int fun(void);
+
+static int foo(int a)
+{
+	return a && fun();
+}
+
+static int bar(int a)
+{
+	return a || fun();
+}
+
+/*
+ * check-name: phi-order01
+ * check-command: sparse -vir -flinearize=last $file
+ */
--- /dev/null	Mon Nov 18 13:20:19 2019
+++ new/usr/src/tools/smatch/src/validation/linear/phi-order02.c	Mon Nov 18 13:20:19 2019
@@ -0,0 +1,16 @@
+int fun(void);
+
+static int foo(int a) { return 0 || fun(); }
+static int bar(int a) { return 1 || fun(); }
+static int baz(int a) { return 0 && fun(); }
+static int qux(int a) { return 1 && fun(); }
+
+static int oof(int a) { return fun() || 1; }
+static int rab(int a) { return fun() || 0; }
+static int zab(int a) { return fun() && 1; }
+static int xuq(int a) { return fun() && 0; }
+
+/*
+ * check-name: phi-order02
+ * check-command: sparse -vir -flinearize=last $file
+ */
--- /dev/null	Mon Nov 18 13:20:20 2019
+++ new/usr/src/tools/smatch/src/validation/linear/phi-order03.c	Mon Nov 18 13:20:20 2019
@@ -0,0 +1,8 @@
+int fun(void);
+
+static int foo(void) { return ((0 || fun()) && fun()); }
+
+/*
+ * check-name: phi-order03
+ * check-command: sparse -vir -flinearize=last $file
+ */
--- /dev/null	Mon Nov 18 13:20:20 2019
+++ new/usr/src/tools/smatch/src/validation/linear/phi-order04.c	Mon Nov 18 13:20:20 2019
@@ -0,0 +1,12 @@
+static void foo(int *b)
+{
+	if (1) {
+		int c;
+		b = &c;
+	}
+}
+
+/*
+ * check-name: phi-order04
+ * check-command: sparse -vir -flinearize=last $file
+ */
--- /dev/null	Mon Nov 18 13:20:20 2019
+++ new/usr/src/tools/smatch/src/validation/linear/range-op.c	Mon Nov 18 13:20:20 2019
@@ -0,0 +1,31 @@
+static void foo(int a)
+{
+	__range__(a, 0, 8);
+}
+
+static void bar(int a, int b, int c)
+{
+	__range__(a, b, c);
+}
+
+/*
+ * check-name: range-op
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+foo:
+.L0:
+	<entry-point>
+	range-check %arg1 between $0..$8
+	ret
+
+
+bar:
+.L2:
+	<entry-point>
+	range-check %arg1 between %arg2..%arg3
+	ret
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:20 2019
+++ new/usr/src/tools/smatch/src/validation/linear/unexamined-base-type.c	Mon Nov 18 13:20:20 2019
@@ -0,0 +1,36 @@
+# define __force	__attribute__((force))
+
+struct s {
+	int a;
+};
+
+static int foo(struct s *s)
+{
+	return (*((typeof(s->a) __force *) &s->a)) & 1;
+}
+
+static void bar(struct s *d, struct s *s1, struct s *s2)
+{
+	*d = *s1, *d = *s2;
+}
+
+/*
+ * check-name: unexamined base type
+ * check-command: test-linearize -Wno-decl $file
+ * check-description:
+ *	Test case for missing examine in evaluate_dereference()'s
+ *	target base type. In this case, the loaded value has a
+ *	a null size, giving the wrongly generated code for foo():
+ *		ptrcast.64  %r3 <- (64) %arg1
+ *		load        %r4 <- 0[%r3]
+ *		    ^^^				!! WRONG !!
+ *		cast.32     %r5 <- (0) %r4
+ *		                   ^^^		!! WRONG !!
+ *		and.32      %r6 <- %r5, $1
+ *		ret.32      %r6
+ *
+ * check-output-ignore
+ * check-output-excludes: load[^.]
+ * check-output-excludes: cast\\..*(0)
+ * check-output-excludes: store[^.]
+ */
--- /dev/null	Mon Nov 18 13:20:20 2019
+++ new/usr/src/tools/smatch/src/validation/linear/unreachable-label0.c	Mon Nov 18 13:20:20 2019
@@ -0,0 +1,19 @@
+static int foo(int a)
+{
+	goto label;
+	switch(a) {
+	default:
+label:
+		break;
+	}
+	return 0;
+}
+
+/*
+ * check-name: unreachable-label0
+ * check-command: test-linearize $file
+ *
+ * check-output-ignore
+ * check-output-contains: ret\\.
+ * check-output-excludes: END
+ */
--- /dev/null	Mon Nov 18 13:20:21 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/address-used00.c	Mon Nov 18 13:20:21 2019
@@ -0,0 +1,18 @@
+int foo(int **g, int j)
+{
+	int i = 1;
+	int *a;
+	int **p;
+
+	a = &i;
+	p = &a;
+	*p[0] = 0;
+	return i;
+}
+
+/*
+ * check-name: address-used00
+ * check-command: test-linearize -Wno-decl -fdump-ir=final $file
+ * check-output-ignore
+ * check-output-excludes: ret\\..* \\$1
+ */
--- /dev/null	Mon Nov 18 13:20:21 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/alias-distinct.c	Mon Nov 18 13:20:21 2019
@@ -0,0 +1,17 @@
+extern int g;
+extern int h;
+
+static int foo(void)
+{
+	g = 1;
+	h = 2;
+	return g == 1;
+}
+
+/*
+ * check-name: alias distinct symbols
+ * check-command: test-linearize $file
+ * check-output-ignore
+ *
+ * check-output-contains: ret\\..* *\\$1
+ */
--- /dev/null	Mon Nov 18 13:20:21 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/alias-mixed.c	Mon Nov 18 13:20:21 2019
@@ -0,0 +1,30 @@
+extern int g;
+
+
+static int foo(int *p)
+{
+	*p = 1;
+	g = 2;
+	return *p == 1;
+}
+
+static int bar(int *p)
+{
+	g = 1;
+	*p = 2;
+	return g == 1;
+}
+
+static void test(void)
+{
+	foo(&g);
+	bar(&g);
+}
+
+/*
+ * check-name: alias symbol/pointer
+ * check-command: test-linearize $file
+ * check-output-ignore
+ *
+ * check-output-excludes: ret\\..* *\\$1
+ */
--- /dev/null	Mon Nov 18 13:20:21 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/alias-same.c	Mon Nov 18 13:20:21 2019
@@ -0,0 +1,17 @@
+extern int g;
+
+
+static int foo(void)
+{
+	g = 1;
+	g = 2;
+	return g != 1;
+}
+
+/*
+ * check-name: alias same symbols
+ * check-command: test-linearize $file
+ * check-output-ignore
+ *
+ * check-output-contains: ret\\..* *\\$1
+ */
--- /dev/null	Mon Nov 18 13:20:21 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/broken-phi02.c	Mon Nov 18 13:20:21 2019
@@ -0,0 +1,27 @@
+int foo(int a, int b)
+{
+	int x;
+	int i;
+
+	if (a)
+		i = 0;
+	else
+		i = 1;
+
+	x = 0;
+	if (b)
+		x = i;
+	return x;
+}
+
+/*
+ * check-name: broken-phi02
+ * check-description:
+ *	This is an indirect test to check correctness of phi-node placement.
+ *	The misplaced phi-node for 'i' (not at the meet point but where 'i'
+ *	is used) causes a missed select-conversion at later stage.
+ *
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ * check-output-contains: select\\.
+ */
--- /dev/null	Mon Nov 18 13:20:21 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/broken-phi03.c	Mon Nov 18 13:20:21 2019
@@ -0,0 +1,28 @@
+int foo(int a, int b)
+{
+	int x;
+	int i;
+
+	switch (a) {
+	case  0: i = 0; break;
+	case  1: i = 1; break;
+	default: i = -1; break;
+	}
+
+	x = 0;
+	if (b)
+		x = i;
+	return x;
+}
+
+/*
+ * check-name: broken-phi03
+ * check-description:
+ *	This is an indirect test to check correctness of phi-node placement.
+ *	The misplaced phi-node for 'i' (not at the meet point but where 'i'
+ *	is used) causes a missed select-conversion at later stage.
+ *
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ * check-output-contains: select\\.
+ */
--- /dev/null	Mon Nov 18 13:20:22 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/cond-expr.c	Mon Nov 18 13:20:22 2019
@@ -0,0 +1,14 @@
+int fun(int);
+
+int foo(int a, int b, int c)
+{
+	return a ? fun(b) : fun(c);
+}
+
+/*
+ * check-name: cond-expr
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(2): phi\\.
+ * check-output-pattern(3): phisrc\\.
+ */
--- /dev/null	Mon Nov 18 13:20:22 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/cond-expr5.c	Mon Nov 18 13:20:22 2019
@@ -0,0 +1,21 @@
+int foo(int p, int q, int a)
+{
+	if (p)
+		a = 0;
+	if (q)
+		a = 1;
+
+	return a;
+}
+
+/*
+ * check-name: cond-expr5
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ *
+ * check-output-ignore
+ * check-output-excludes: load\\.
+ * check-output-excludes: store\\.
+ * check-output-excludes: phi\\..*, .*, .*
+ * check-output-pattern(3): phi\\.
+ * check-output-pattern(5): phisrc\\.
+ */
--- /dev/null	Mon Nov 18 13:20:22 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/dead-phisrc.c	Mon Nov 18 13:20:22 2019
@@ -0,0 +1,17 @@
+static void foo(void)
+{
+	extern int *a;
+
+	if (a || *a)
+		;
+	if (a[0] || a[1])
+		;
+}
+
+/*
+ * check-name: dead-phisrc
+ * check-command: test-linearize $file
+ *
+ * check-output-ignore
+ * check-output-excludes: phisrc
+ */
--- /dev/null	Mon Nov 18 13:20:22 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/global-direct-undef.c	Mon Nov 18 13:20:22 2019
@@ -0,0 +1,23 @@
+int a, c, d;
+
+int foo(void)
+{
+	int b, e;
+	if (a)
+		b = c;
+	else
+		b = d;
+	if (c)
+		a = b;
+	if (b)
+		e = a;
+	return e;
+}
+
+/*
+ * check-name: global direct undef
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(4,5): load\\.
+ * check-output-pattern(1): store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:22 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/global-direct.c	Mon Nov 18 13:20:22 2019
@@ -0,0 +1,23 @@
+int a, c, d;
+
+int foo(void)
+{
+	int b, e = 0;
+	if (a)
+		b = c;
+	else
+		b = d;
+	if (c)
+		a = b;
+	if (b)
+		e = a;
+	return e;
+}
+
+/*
+ * check-name: global direct
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(4,5): load\\.
+ * check-output-pattern(1): store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:22 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/global-loop.c	Mon Nov 18 13:20:22 2019
@@ -0,0 +1,20 @@
+struct s {
+	int c;
+	int a[];
+} s;
+int f;
+
+void fun(void);
+void foo(void)
+{
+	for (f = 1;;)
+		if (s.a[f])
+			fun();
+}
+
+/*
+ * check-name: global var as loop index
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-contains: load\\..*\\[f\\]
+ */
--- /dev/null	Mon Nov 18 13:20:22 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/global-noalias.c	Mon Nov 18 13:20:22 2019
@@ -0,0 +1,21 @@
+int a, b, c, d, e;
+
+void foo(void)
+{
+	if (a)
+		b = c;
+	else
+		b = d;
+	if (c)
+		a = b;
+	if (b)
+		e = a;
+}
+
+/*
+ * check-name: global no-alias
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(4,7): load\\.
+ * check-output-pattern(4): store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:23 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/global-pointer.c	Mon Nov 18 13:20:23 2019
@@ -0,0 +1,26 @@
+int a, c, d;
+
+int foo_ptr(void)
+{
+	int b, *bp = &b;
+	int e, *ep = &e;
+
+	if (a)
+		*bp = c;
+	else
+		*bp = d;
+	if (c)
+		a = *bp;
+	if (b)
+		e = a;
+	return e;
+}
+
+/*
+ * check-name: global pointer
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-known-to-fail
+ * check-output-ignore
+ * check-output-pattern(4,5): load\\.
+ * check-output-pattern(3): store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:23 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/if-direct.c	Mon Nov 18 13:20:23 2019
@@ -0,0 +1,19 @@
+int foo(int c, int a, int b)
+{
+	int l;
+
+	if (c)
+		l = a;
+	else
+		l = b;
+
+	return l;
+}
+
+/*
+ * check-name: if-then-else direct
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-excludes: load\\.
+ * check-output-contains: phi\\.
+ */
--- /dev/null	Mon Nov 18 13:20:23 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/if-pointer.c	Mon Nov 18 13:20:23 2019
@@ -0,0 +1,21 @@
+int foo(int c, int a, int b)
+{
+	int l, *p = &l;
+
+	if (c)
+		*p = a;
+	else
+		*p = b;
+
+	return l + *p;
+}
+
+/*
+ * check-name: if-then-else pointer
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-known-to-fail
+ * check-output-ignore
+ * check-output-excludes: load\\.
+ * check-output-excludes: store\\.
+ * check-output-contains: phi\\.
+ */
--- /dev/null	Mon Nov 18 13:20:23 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/init-global-array.c	Mon Nov 18 13:20:23 2019
@@ -0,0 +1,21 @@
+struct s {
+	int a[2];
+};
+
+
+static struct s s;
+
+static int sarray(void)
+{
+	s.a[1] = 1;
+	return s.a[1];
+}
+
+/*
+ * check-name: init global array
+ * check-command: test-linearize $file
+ * check-output-ignore
+ * check-output-excludes: load\\.
+ * check-output-pattern(1): store\\.
+ * check-output-pattern(1): ret.32 *\\$1
+ */
--- /dev/null	Mon Nov 18 13:20:23 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/init-local-array.c	Mon Nov 18 13:20:23 2019
@@ -0,0 +1,28 @@
+static int array(void)
+{
+	int a[2];
+
+	a[1] = 1;
+	a[0] = 0;
+	return a[1];
+}
+
+static int sarray(void)
+{
+	struct {
+		int a[2];
+	} s;
+
+	s.a[1] = 1;
+	s.a[0] = 0;
+	return s.a[1];
+}
+
+/*
+ * check-name: init local array
+ * check-command: test-linearize $file
+ * check-output-ignore
+ * check-output-excludes: load
+ * check-output-excludes: store
+ * check-output-pattern(2): ret.32 *\\$1
+ */
--- /dev/null	Mon Nov 18 13:20:23 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/init-local-union0.c	Mon Nov 18 13:20:23 2019
@@ -0,0 +1,18 @@
+double uintfloat(void)
+{
+	union {
+		int a;
+		double f;
+	} s;
+
+	s.a = 1;
+	return s.f;
+}
+
+/*
+ * check-name: init-local union 0
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(1): store\\.32
+ * check-output-pattern(1): load\\.64
+ */
--- /dev/null	Mon Nov 18 13:20:24 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/init-local-union1.c	Mon Nov 18 13:20:24 2019
@@ -0,0 +1,32 @@
+double uintfloat(void)
+{
+	union {
+		int a;
+		double f;
+	} s;
+
+	s.a = 1;
+	return s.f;
+}
+
+
+int uarray(void)
+{
+	union {
+		double d;
+		int a[2];
+	} s;
+
+	s.d = 1;
+	return s.a[0];
+}
+
+/*
+ * check-name: init-local union 1
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(1): store\\.32
+ * check-output-pattern(1): load\\.64
+ * check-output-pattern(1): store\\.64
+ * check-output-pattern(1): load\\.32
+ */
--- /dev/null	Mon Nov 18 13:20:24 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/init-local32.c	Mon Nov 18 13:20:24 2019
@@ -0,0 +1,27 @@
+int ssimple(void)
+{
+	struct {
+		int a;
+	} s;
+
+	s.a = 1;
+	return s.a;
+}
+
+double sdouble(void)
+{
+	struct {
+		double a;
+	} s;
+
+	s.a = 1.23;
+	return s.a;
+}
+
+/*
+ * check-name: init-local32
+ * check-command: test-linearize -Wno-decl -m32 -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-excludes: load\\.
+ * check-output-excludes: store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:24 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/init-local64.c	Mon Nov 18 13:20:24 2019
@@ -0,0 +1,27 @@
+int ssimple(void)
+{
+	struct {
+		int a;
+	} s;
+
+	s.a = 1;
+	return s.a;
+}
+
+double sdouble(void)
+{
+	struct {
+		double a;
+	} s;
+
+	s.a = 1.23;
+	return s.a;
+}
+
+/*
+ * check-name: init-local64
+ * check-command: test-linearize -Wno-decl -m64 -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-excludes: load\\.
+ * check-output-excludes: store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:24 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/load-dead.c	Mon Nov 18 13:20:24 2019
@@ -0,0 +1,18 @@
+int fun(int);
+
+static inline int fake(void)
+{
+}
+
+static void foo(int a)
+{
+	0 || fun((a, fake(), a));
+}
+
+/*
+ * check-name: load-dead
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: VOID
+ */
--- /dev/null	Mon Nov 18 13:20:24 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/load-deadborn.c	Mon Nov 18 13:20:24 2019
@@ -0,0 +1,9 @@
+static void foo(int a)
+{
+	return;
+	a;
+}
+
+/*
+ * check-name: load-deadborn
+ */
--- /dev/null	Mon Nov 18 13:20:24 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/loop00.c	Mon Nov 18 13:20:24 2019
@@ -0,0 +1,16 @@
+int loop00(int n)
+{
+	int i, r = 0;
+
+	for (i = 1; i <= n; ++i)
+		r += i;
+	return r;
+}
+
+/*
+ * check-name: loop00
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-excludes: store\\.
+ * check-output-excludes: load\\.
+ */
--- /dev/null	Mon Nov 18 13:20:24 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/loop01-global.c	Mon Nov 18 13:20:24 2019
@@ -0,0 +1,18 @@
+extern int g;
+
+void fun(void);
+void loop01(void)
+{
+	int i;
+	for (i = 0; i <= 2;)
+		if (g)
+			fun();
+}
+
+/*
+ * check-name: loop01 global
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-excludes: load\\..*\\[i\\]
+ * check-output-contains: load\\..*\\[g\\]
+ */
--- /dev/null	Mon Nov 18 13:20:25 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/loop02-array.c	Mon Nov 18 13:20:25 2019
@@ -0,0 +1,23 @@
+
+
+int foo(int i[])
+{
+	int j = 1;
+	i[0] = 6;
+
+	do {
+		if (i[0] != 6)
+			i[0]++;
+		i[0]++;
+	} while (i[0] != j);
+
+	return j;
+}
+
+/*
+ * check-name: loop02 array
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(0,4): load\\.
+ * check-output-pattern(1,3): store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:25 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/loop02-global.c	Mon Nov 18 13:20:25 2019
@@ -0,0 +1,22 @@
+int i;
+
+int foo(void)
+{
+	int j = 1;
+	i = 6;
+
+	do {
+		if (i != 6)
+			i++;
+		i++;
+	} while (i != j);
+
+	return j;
+}
+
+/*
+ * check-name: loop02 global
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ * check-output-excludes: load\\.
+ */
--- /dev/null	Mon Nov 18 13:20:25 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/loop02-local.c	Mon Nov 18 13:20:25 2019
@@ -0,0 +1,23 @@
+
+
+int foo(void)
+{
+	int j = 1;
+	int i = 6;
+
+	do {
+		if (i != 6)
+			i++;
+		i++;
+	} while (i != j);
+
+	return j;
+}
+
+/*
+ * check-name: loop02 pointer
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ *
+ * check-output-ignore
+ * check-output-excludes: load\\.
+ */
--- /dev/null	Mon Nov 18 13:20:25 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/loop02-pointer.c	Mon Nov 18 13:20:25 2019
@@ -0,0 +1,23 @@
+
+
+int foo(int *i)
+{
+	int j = 1;
+	*i = 6;
+
+	do {
+		if (*i != 6)
+			(*i)++;
+		(*i)++;
+	} while (*i != j);
+
+	return j;
+}
+
+/*
+ * check-name: loop02 pointer
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-pattern(0,4): load\\.
+ * check-output-pattern(1,3): store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:25 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/missing-return.c	Mon Nov 18 13:20:25 2019
@@ -0,0 +1,34 @@
+int f1(void)
+{
+	if (1)
+		return 1;
+}
+
+int f0(void)
+{
+	if (0)
+		return 0;
+}
+
+int fx(int p)
+{
+	if (p)
+		return 0;
+}
+
+int bar(int p)
+{
+	if (p)
+		return 0;
+	p++;
+}
+
+/*
+ * check-name: missing-return
+ * check-command: test-linearize -m32 -fdump-ir=mem2reg -Wno-decl $file
+ * check-known-to-fail
+ *
+ * check-output-ignore
+ * check-output-pattern(1): ret.32 *\\$1
+ * check-output-pattern(3): ret.32 *UNDEF
+ */
--- /dev/null	Mon Nov 18 13:20:25 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/quadra00.c	Mon Nov 18 13:20:25 2019
@@ -0,0 +1,27 @@
+#define	TEST(N)			\
+	do {			\
+		d = b + a[N];	\
+		if (d < b)	\
+			c++;	\
+		b = d;		\
+	} while (0)
+
+int foo(int *a, int b, int c)
+{
+	int d;
+
+	TEST(0);
+	TEST(1);
+	TEST(2);
+
+	return d + c;
+}
+
+/*
+ * check-name: quadratic phisrc
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ * check-output-excludes: phi\\..*, .*, .*
+ * check-output-excludes: phi\\..*, .*, .*, .*
+ * check-output-pattern(6): phisrc\\.
+ */
--- /dev/null	Mon Nov 18 13:20:25 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/quadra01.c	Mon Nov 18 13:20:25 2019
@@ -0,0 +1,27 @@
+#include "repeat.h"
+
+void use(void *, void *, void *, void *);
+void *def(void);
+
+#define BLOCK(n) {				\
+	void *label;				\
+	use(&&w##n, &&x##n, &&y##n, &&z##n);	\
+w##n:	label = def(); goto *label;		\
+x##n:	label = def(); goto *label;		\
+y##n:	label = def(); goto *label;		\
+z##n:	label = def(); goto *label;		\
+}
+
+static void foo(void) {
+	REPEAT2(5, BLOCK)
+}
+
+/*
+ * check-name: quadratic @ liveness
+ * check-command: test-linearize -I. $file
+ * check-timeout:
+ *
+ * check-output-ignore
+ * check-output-excludes: phi\\.
+ * check-output-excludes: phisrc\\.
+ */
--- /dev/null	Mon Nov 18 13:20:26 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/quadra02.c	Mon Nov 18 13:20:26 2019
@@ -0,0 +1,18 @@
+#include "repeat.h"
+
+#define	PAT(X)	int a##X = X;
+static void foo(void)
+{
+	REPEAT2(12, PAT)
+}
+
+/*
+ * check-name: quadratic vars
+ * check-command: test-linearize -I. $file
+ * check-timeout:
+ *
+ * check-output-ignore
+ * check-output-excludes: phi\\.
+ * check-output-excludes: phisrc\\.
+ * check-output-excludes: store\\.
+ */
--- /dev/null	Mon Nov 18 13:20:26 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/reload-aliasing.c	Mon Nov 18 13:20:26 2019
@@ -0,0 +1,41 @@
+extern int g, h;
+
+void f00(int *s)
+{
+	g = *s;
+	h = *s;
+}
+
+void f01(int *a, int *b, int *s)
+{
+	*a = *s;
+	*b = *s;
+}
+
+/*
+ * check-name: reload-aliasing.c
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-start
+f00:
+.L0:
+	<entry-point>
+	load.32     %r2 <- 0[%arg1]
+	store.32    %r2 -> 0[g]
+	load.32     %r4 <- 0[%arg1]
+	store.32    %r4 -> 0[h]
+	ret
+
+
+f01:
+.L2:
+	<entry-point>
+	load.32     %r6 <- 0[%arg3]
+	store.32    %r6 -> 0[%arg1]
+	load.32     %r9 <- 0[%arg3]
+	store.32    %r9 -> 0[%arg2]
+	ret
+
+
+ * check-output-end
+ */
--- /dev/null	Mon Nov 18 13:20:26 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/short-load.c	Mon Nov 18 13:20:26 2019
@@ -0,0 +1,29 @@
+#ifdef __SIZEOF_INT__ == 4
+typedef unsigned int u32;
+#endif
+#ifdef __SIZEOF_SHORT__ == 2
+typedef unsigned short u16;
+#endif
+
+
+union u {
+	u32	a;
+	u16	b;
+};
+
+void bar(u16, union u);
+
+void foo(u16 val)
+{
+	union u u;
+
+	u.b = val;
+	bar(u.b, u);
+}
+
+/*
+ * check-name: short-load
+ * check-command: test-linearize -Wno-decl -fdump-ir=mem2reg $file
+ * check-output-ignore
+ * check-output-contains: load\\.32
+ */
--- /dev/null	Mon Nov 18 13:20:26 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/store-deadborn.c	Mon Nov 18 13:20:26 2019
@@ -0,0 +1,9 @@
+static void foo(int a)
+{
+	return;
+	a = 0;
+}
+
+/*
+ * check-name: store-deadborn
+ */
--- /dev/null	Mon Nov 18 13:20:26 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/stray-phisrc.c	Mon Nov 18 13:20:26 2019
@@ -0,0 +1,24 @@
+static int foo(int **g)
+{
+	int i = 1;
+	int *a[2];
+	int **p;
+
+	a[1] = &i;
+	if (g)
+		p = g;
+	else
+		p = &a[0];
+	p += 1;			// will point to a[1] = &i
+	if (!g)
+		**p = 0;
+	return i;
+}
+
+/*
+ * check-name: stray phisrc
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-excludes: phisrc\\.
+ */
--- /dev/null	Mon Nov 18 13:20:26 2019
+++ new/usr/src/tools/smatch/src/validation/mem2reg/struct.c	Mon Nov 18 13:20:26 2019
@@ -0,0 +1,32 @@
+struct s {
+	int a;
+	int b;
+};
+
+int f0(void)
+{
+	struct s s;
+
+	s.a = 0;
+	s.b = 1;
+
+	return s.a;
+}
+
+int f1(void)
+{
+	struct s s;
+
+	s.a = 1;
+	s.b = 0;
+
+	return s.b;
+}
+
+/*
+ * check-name: struct
+ * check-command: test-linearize -Wno-decl $file
+ *
+ * check-output-ignore
+ * check-output-pattern(2): ret.32 *\\$0
+ */
